
' program Antykret
' autor: Marian Gabrowski
' uwaga: 
'       w zrealizowanym ukladzie czestotliwosc rezonatora RC to chyba 1MHz a w programie zostalo 8MHz



$regfile = "attiny25.dat"
$crystal = 8000000

Config Timer0 = Timer , Prescale = 1024
On Timer0 Przerwanie
Enable Interrupts
Enable Timer0
Config Watchdog = 2048
Start Watchdog

Config Pinb.4 = Output
Spk Alias Portb.4

Stop Ac
Stop Adc

Dim A As Integer
Dim B As Integer
Dim C As Integer
Dim D As Integer

Dim Licznik As Byte
Dim Licznik_max As Byte
Dim Efekt As Byte

Do
  If Licznik = Licznik_max Then
    Licznik = 0
    Licznik_max = Rnd(250)
    Efekt = Rnd(5)
    Select Case Efekt
      Case 1 : Gosub Efekt1
      Case 2 : Gosub Efekt2
      Case 3 : Gosub Efekt3
      Case 4 : Gosub Efekt4
      Case 5 : Gosub Efekt5
    End Select
  End If
  Idle
Loop
End

Przerwanie:
  Incr Licznik
  Reset Watchdog
Return

Efekt1:
  A = Rnd(75)
  B = Rnd(750)
  For C = 0 To A
    Set Spk
    For D = 0 To B : Nop : Next D
    Reset Spk
    For D = 0 To B : Nop : Next D
  Next C
Return

Efekt2:
  D = Rnd(200)
  For A = 1 To D
    Set Spk
    For B = 0 To A : Nop : Next B
    Reset Spk
    For B = 0 To A : Nop : Next B
  Next A
Return

Efekt3:
  For A = 200 To 1 Step -1
    Set Spk
    For B = 0 To A : Nop : Next B
    Reset Spk
    For B = 0 To A : Nop : Next B
  Next A
Return

Efekt4:
   For A = 1 To 50
     Set Spk
     B = Rnd(100)
     For C = 0 To B : Nop : Next C
     Reset Spk
     For C = 0 To B : Nop : Next C
   Next A
Return

Efekt5:
   A = Rnd(50)
   For B = 0 To A
     Set Spk
     C = Rnd(1000)
     For D = 0 To C : Nop : Next D
     Reset Spk
     C = Rnd(100)
     For D = 0 To C : Nop : Next D
   Next B
Return